package com.bonus.material.ma.mapper;

import java.util.List;

import com.bonus.material.lease.domain.LeaseOutDetails;
import com.bonus.material.ma.domain.Machine;
import com.bonus.material.ma.domain.Type;
import com.bonus.material.ma.domain.vo.MachineVo;
import org.apache.ibatis.annotations.Param;

/**
 * 机具设备管理Mapper接口
 * 
 * @author xsheng
 * @date 2024-09-27
 */
public interface MachineMapper 
{
    /**
     * 查询机具设备管理
     * 
     * @param maId 机具设备管理主键
     * @return 机具设备管理
     */
    public MachineVo selectMachineByMaId(Long maId);

    /**
     * 查询机具设备管理列表
     * 
     * @param machine 机具设备管理
     * @return 机具设备管理集合
     */
    public List<MachineVo> selectMachineList(Machine machine);

    /**
     * 新增机具设备管理
     * 
     * @param machine 机具设备管理
     * @return 结果
     */
    public int insertMachine(Machine machine);

    /**
     * 修改机具设备管理
     * 
     * @param machine 机具设备管理
     * @return 结果
     */
    public int updateMachine(Machine machine);

    /**
     * 删除机具设备管理
     * 
     * @param maId 机具设备管理主键
     * @return 结果
     */
    public int deleteMachineByMaId(Long maId);

    /**
     * 批量删除机具设备管理
     * 
     * @param maIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteMachineByMaIds(Long[] maIds);

    /**
     * 查询机具设备管理列表
     * @param type
     * @return
     */
    List<Type> selectByTypeList(Type type);

    String getMachineStatus(LeaseOutDetails record);

    /**
     * 修改机具设备(ma_machine表)的状态为：在用
     */
    int updateMaMachineStatus(@Param("record") LeaseOutDetails leaseOutDetails, @Param("status") Integer status);
}
